



local require = GLOBAL.require
local TheInput = GLOBAL.TheInput
local TheCamera = GLOBAL.TheCamera

-- local commited_forward = false


AddComponentPostInit("playercontroller", function(self) 
	function self:GetCursorInventoryObject()
		-- if self.inst.HUD ~= nil and TheInput:ControllerAttached() then
		-- print("GetCursorInventoryObject")
		if self.inst.HUD ~= nil and (GLOBAL.TheInput:ControllerAttached() or GLOBAL.GetPlayer().FPSmode == true) then
			local item = self.inst.HUD.controls.inv:GetCursorItem()
			return item ~= nil and item:IsValid() and item or nil
		end
	end
	
	
	--SPECIAL HANDLER THAT PREVENTS WALKING FORWARD FROM OVERWRITING A BUFFERED ACTION IF LOOKING AT IT
	-- function self:GetRemoteDirectVector()
		-- -- print("REMOTE WALKIN HERE")
		-- if self.inst:GetBufferedAction() ~= nil then return end
		
		-- return self.remote_vector.y == 1 and self.remote_vector or nil
	-- end
-- end)






local function GetWorldControllerVector()
    local xdir = TheInput:GetAnalogControlValue(GLOBAL.CONTROL_MOVE_RIGHT) - TheInput:GetAnalogControlValue(GLOBAL.CONTROL_MOVE_LEFT)
    local ydir = TheInput:GetAnalogControlValue(GLOBAL.CONTROL_MOVE_UP) - TheInput:GetAnalogControlValue(GLOBAL.CONTROL_MOVE_DOWN)
    local deadzone = .3
    if math.abs(xdir) >= deadzone or math.abs(ydir) >= deadzone then
        local dir = GLOBAL.TheCamera:GetRightVec() * xdir - GLOBAL.TheCamera:GetDownVec() * ydir
        return dir:GetNormalized()
    end
end



--4-11-18 OH WOW, THIS IS A LOT EASIER FOR VANILLA DS
	function self:DoDirectWalking(dt)

		local dir = self:GetWorldControllerVector()
		if dir then
			local ang = -math.atan2(dir.z, dir.x)/GLOBAL.DEGREES
			
			
			--4-11-18 LETS JUST THROW IT ALL DOWN RIGHT HERE
			--DO THEY HAVE A BUFFER TARGET? ARE THEY LOOKING AT IT?
			local focusdown = false --IF THEY SHOULD IGNORE THEIR RUNNING FORWARD COMMAND TO COMPLETE THE TASK RIGHT IN FRONT OF THEM
			
			--"GETBUFFEREDACTION()" DOESNT EXIST IN VANILLA  --ITS NOW   self.inst.bufferedaction
			-- if self.inst:GetBufferedAction() and self.inst:GetBufferedAction().target ~= nil then
			if self.inst.bufferedaction and self.inst.bufferedaction.target ~= nil then
				print("BUFFERED ACTION", tostring(self.inst.bufferedaction.action[0]))
				local target = self.inst.bufferedaction.target
				local lookingat = self.inst.components.retmanager:IsPlayerLookingAt(self.inst, target, 45)
				-- print("AM I LOOKING AT", lookingat)
				if lookingat == true and self.inst.bufferedaction ~= nil 
					-- and not self.inst.components.playercontroller:IsAnyOfControlsPressed(GLOBAL.CONTROL_MOVE_DOWN, GLOBAL.CONTROL_MOVE_LEFT, GLOBAL.CONTROL_MOVE_RIGHT) then
					--IN VANILLA, WE MUST TEST THEM INDIVIDUALLY
					and not (TheInput:IsControlPressed(GLOBAL.CONTROL_MOVE_DOWN) or TheInput:IsControlPressed(GLOBAL.CONTROL_MOVE_LEFT) or TheInput:IsControlPressed(GLOBAL.CONTROL_MOVE_RIGHT)) then
					focusdown = true
				end
			end
			
			
			-- local x, y, z = self.inst.Transform:GetPredictionPosition()
			-- -- if x ~= nil and y ~= nil and z ~= nil then
			-- if x ~= nil and y ~= nil and z ~= nil and not focusdown then
				-- self:RemotePredictWalking(x, z)
				-- -- print("REMOTE PREDICT WALKING") --BOYS... IT TURNS OUT PREDICTWALKING ALLOWS US TO KEEP OUR BUFFERED ACTIONS
			-- end
			
			if focusdown == true then --THEN WE BUSY. DONT BOTHER US RIGHT NOW
				print ("FOCUS DOWN CONTIRMED")
				return end --OKAY NO WAIT, WE STILL NEED TO ACTUALLY RUN TO OUR OBJECTIVE
			
			

			self.inst:ClearBufferedAction()
			self.inst.components.locomotor:SetBufferedAction(nil)
			self.inst.components.locomotor:RunInDirection(ang)
			if not self.directwalking then
				self.time_direct_walking = 0
			end

			self.directwalking = true

			self.time_direct_walking = self.time_direct_walking + dt

			if self.time_direct_walking > .2 then
				
				if not self.inst.sg:HasStateTag("attack") then
					if GLOBAL.GetPlayer().FPSmode == true then
						--4-12-18 REMOVING TO ALLOW PLAYERS TO SWING AT ENEMIES EASIER
						--OKAY, HOW ABOUT WE CAN CANCEL IT IF WE ARE HOLDING ANY OF THE CURRENT BUTTONS DOWN
						if (TheInput:IsControlPressed(GLOBAL.CONTROL_MOVE_DOWN) or TheInput:IsControlPressed(GLOBAL.CONTROL_MOVE_LEFT) or TheInput:IsControlPressed(GLOBAL.CONTROL_MOVE_RIGHT)) then
							self.inst.components.combat:SetTarget(nil) --YEA SURE, GET RID OF THIS. WHAT COULD GO WRONG?... WELL, LETS NOT ANSWER THAT
						end
						
					else
						self.inst.components.combat:SetTarget(nil) --FINE SURE, LET THEM DO IT THE NORMAL WAY
					end
				end
			end
		else
			if self.directwalking then
				self.inst.components.locomotor:Stop()
				self.directwalking = false
			end
		end
	end

end)